/*******************************************************************************
********************************************************************************
***                                                                           **
***                         INTEL CONFIDENTIAL                                **
***                    COPYRIGHT 2011 INTEL CORPORATION                       **
***                         All Rights Reserved                               **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***     The source code contained or described herein and all documents       **
***     related to the source code ("Material") are owned by Intel            **
***     Corporation or its suppliers or licensors. Title to the Material      **
***     remains with Intel Corporation or its suppliers and licensors.        **
***     The Material contains trade secrets and proprietary and confidential  **
***     information of Intel or its suppliers and licensors.                  **
***     The Material is protected by worldwide copyright and trade secret     **
***     laws and treaty provisions. No part of the Material may be used,      **
***     copied, reproduced, modified, published, uploaded, posted,            **
***     transmitted, distributed, or disclosed in any way without Intels     **
***     prior express written permission.                                     **
***                                                                           **
***     No license under any patent, copyright, trade secret or other         **
***     intellectual property right is granted to or conferred upon you by    **
***     disclosure or delivery of the Materials, either expressly, by         **
***     implication, inducement, estoppel or otherwise. Any license under     **
***     such intellectual property rights must be express and approved by     **
***     Intel in writing.                                                     **
********************************************************************************/
/*
 * DCMI1_1ConformanceSuit.h
 *
 *  Created on: 04-04-2011
 */

#ifndef DCMI1_1CONFORMANCESUIT_H_
#define DCMI1_1CONFORMANCESUIT_H_

#include "DCMI_Discovery_lib.h"

/*
 *
 */

namespace DCMIConformance
{

class DCMI1_1ConformanceSuite: public DCMIDiscovery
{

public:
	DCMI1_1ConformanceSuite(int ver =  ((0x1<<8) + (0x1)) /*0x0101*/);

	void runSuite(TestUtil::TestOutput &out)
	{
		out.print_header("\n"\
						"           DCMI 1.1 Conformance Suite\n"\
						"    ---------------------------------------\n");
		DCMIDiscovery::runSuite(out);
	}


protected:

};

class DCMICipherCheck: public DCMIDiscovery
{

public:
	DCMICipherCheck(int ver);

	void runSuite(TestUtil::TestOutput &out)
	{
		out.print_header("\n"\
								"           DCMI Cipher Check Suite\n"\
								"    ---------------------------------------\n");
		DCMIDiscovery::runSuite(out);
	}

};

}

#endif /* DCMI1_1CONFORMANCESUIT_H_ */
