/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
/*******************************************************************************
***		 File		:	DCMI_IPMGlobal_lib.h  							      **
***																			  **
********************************************************************************/



#define GET_DEV_GUID_MIN_RSPLEN	16	//Minimum response length for GetDevice GUID command
#define GET_DEV_GUID_MAX_RSPLEN	16	//Maximum response length for GetDevice GUID command

#define GET_ASSET_MIN_RSPLEN	02		//Minimum expected response length for Get Asset Tag Command
#define GET_ASSET_MAX_RSPLEN	18		//Maximum expected response length for Get Asset Tag Command

#define	ASSET_TAG_MAX_LEN		64		//Maximum length of characters in AssetTag is 64
										// Table 6-4 FRU product area of DCMI 1.0 spec
										// defines this.

#define GET_ASSET_TAG_MAX_BYTES_TO_READ 16  //GET ASSET TAG command allows reading
											//Asset Tag 16 bytes at a time
											//Sec.6.4.1.1 of DCMI 1.0 spec


#define	MCID_MAX_LEN		64			//Maximum length of characters in MC ID String is 64

#define GET_MCID_MAX_BYTES_TO_READ 16  //Get MC ID String command allows reading
										// 16 bytes at a time
#define GET_MCID_MIN_RSPLEN	02		//Minimum expected response length for Get MC ID String Command
#define GET_MCID_MAX_RSPLEN	18		//Maximum expected response length for Get Asset Tag Command


//s_get_asset_tag_rsp defines the Response structure for Get Asset Tag Command
struct s_get_asset_tag_rsp
{
	byte_t	bCompCode;									//Command Completion Code
	byte_t	bGrpExtID;									//Group Extension IDentification = DCh
	byte_t	bAssetTagLen;								//Asset Tag Length
	byte_t	bAssetTag[GET_ASSET_TAG_MAX_BYTES_TO_READ];	//Asset Tag data read
	byte_t  bNumBytes;									//number of valid bytes in bAssetTag array
};

//s_get_mcid_string_rsp defines the Response structure for Get Asset Tag Command
struct s_get_mcid_string_rsp
{
	byte_t	bCompCode;									//Command Completion Code
	byte_t	bGrpExtID;									//Group Extension IDentification = DCh
	byte_t	bMcidStringLen;								//Mcid String Length
	byte_t	bMcidString[GET_MCID_MAX_BYTES_TO_READ];	//Mcid String data read
	byte_t  bNumBytes;									//number of valid bytes in bAssetTag array
};

//#define GOOD_ASSET_TAG_CCODE(CCode) ((CCode==0)||(CCode == 0x80)||(CCode == 0x81)||(CCode == 0x82)||(CCode == 0x83))



