/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
/*******************************************************************************
***		 File		:	DCMI_SDR_lib.h		  								  **
***																			  **
********************************************************************************/
//Define the Response length expected as in IPMI/DCMI spec

#define GET_SDR_MIN_RSPLEN	2			   // Minimum response length for Get SDR command
#define GET_SDR_MAX_RSPLEN	MAX_IPMI_SIZE  // Max response length for Get SDR Command

#define RESERVE_SDR_MIN_RSPLEN	2		   // Min response length for Reserve SDR Respository command
#define RESERVE_SDR_MAX_RSPLEN	2		   // Max response length for Reserve SDR Respository command

#define GET_SDR_REP_INFO_MIN_RSPLEN	14	   // Min response length for Get SDR Respository Info command
#define GET_SDR_REP_INFO_MAX_RSPLEN	14	   // Max response length for Get SDR Respository Info command

#include "DCMI_Chassis_lib.h"

class SDRBase: public ChassisBase //DCMIClasses::DCMIBaseTest
{

public:

protected:
   SDRBase(std::string name, TransportPlugin::TransportPlugIn &transport) :
      ChassisBase(name, transport)
   { }

	void getSdrRepositoryInfo(std::vector<byte_t> &resp_data);
	void reserveSdr(byte_t &reservationIdLsb, byte_t  &reservationIdMsb);
	void getSdrValues(byte_t recordIdLsb, byte_t recordIdMsb, byte_t reservationIdLsb, byte_t reservationIdMsb,
			byte_t offset, byte_t bytesToRead, s_sdr_data &sdrReturnValues);


};

/**
 *
 */
class SDRTest: public SDRBase
{

public:
	SDRTest(TransportPlugin::TransportPlugIn &transport) :
		SDRBase("DCMI SDR Tests", transport)
	{

		ADD_TEST(SDRTest::SDRRepositoryInfoCheckTest, "Checking SDR Repository Info", TestUtil::TT_MANDATORY);
	}

	TestResult 	SDRRepositoryInfoCheckTest(any_value &);

protected:


};
