/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
/*******************************************************************************
***		 File		:	DCMI_Tmode_lib.h    							      **
***																			  **
********************************************************************************/
//Define the Response length expected as in IPMI/DCMI spec

#define GET_TMODE_CONFIG_MAX_RSPLEN	5	//Max Response length for Get Serial/Modem Config Command
#define GET_TMODE_CONFIG_MIN_RSPLEN	2	//Min Response length for Get Serial/Modem Config Command

#include "DCMIClasses.hpp"

/**
 * Perform the test cases related to TMode feature support.
 * Verifies that the platform supports the feature as per DCMI/IPMI specification
 */
class TmodeTest: public DCMIClasses::DCMIBaseTest
{
	int m_channelNum;
	int m_TmodePresent;

public:

	TmodeTest(byte_t TmodePresent, byte_t channel, TransportPlugin::TransportPlugIn &transport) :
		DCMIBaseTest("DCMI TMode Tests", transport)
	{
		m_channelNum = channel;
		m_TmodePresent = TmodePresent;

		TestUtil::TestType tt = TestUtil::TT_OPTIONAL;
		if (m_TmodePresent == 1)
			tt  = TestUtil::TT_MANDATORY;

		ADD_TEST(TmodeTest::ValidateTModeConfigTest, "TMODE Support Test", tt);
	}

	TestResult ValidateTModeConfigTest(any_value &);

protected:

	void getSerialModemConfig(int iSerModParam, int iSetSelector, int iBlockSelector, std::vector<byte_t> &resp_data);

};
