/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2011 INTEL CORPORATION                       **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
/*
 * TransportManager.h
 *
 *  Created on: 31-03-2011
 */

#ifndef TRANSPORTMANAGER_H_
#define TRANSPORTMANAGER_H_

#include "TransportCommon.h"

namespace TransportPlugin
{

class TransportManager
{

protected:

	/**************************************************************************
	Function declaration
	transport_plugin_id UserOption2PluginId(UserOption option);
	Function Name   :   UserOption2PluginId
	Purpose         :   Matches the user option to the Transport number
	Parameters      :
	               [IN] option - The interface / transport being used

	Returns         :   Returns the corresponding transport plugin ID
	***************************************************************************/
	static transport_plugin_id UserOption2PluginId(UserOption option)
	{
		if(option==IB_KCS_HECI)
			return TP_INB;
		return TP_RMCPP;
	}

	static std::string UserOption2ConfigName(UserOption option)
	{
		if(option==IB_KCS_HECI)
			return "INBAND";
		return "RMCPP";
	}

public:

	static void doConfigure(UserOption useropt, DcmiConfiguration &config) /*throw(...)*/;

	static TransportPlugIn &getCurrentTransport() /*throw(...)*/;

	static void connect();

	static void disconnect() throw();

	//static void setSessionPrivilegeLevel(PrivelegeLevel level);

	static transport_plugin_id connectionType();

};


}//end namespace
#endif /* TRANSPORTMANAGER_H_ */
