/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/

#ifndef _LOGLEVEL_H
#define _LOGLEVEL_H

namespace TransportPlugin
{

/**
 * Defines logging verbosity levels.
 */
enum LogLevel
{
    logLevelErrors   = 0,   ///< error information (must always be written to the logs!)
    logLevelSummary  = 10,  ///< summary information about DCMI test execution almost nothing info
    logLevelDetails  = 20,  ///< detailed information about DCMI command execution
    logLevelWarnings = 30,  ///< warnings and more info generally transport layer
    logLevelInfo     = 40, ///< more info
    logLevelDebug    = 50, ///< high-level debug info
};

}

#endif //_LOGLEVEL_H
