/*******************************************************************************
********************************************************************************
***                                                                           **
***	                           INTEL CONFIDENTIAL                             **
***                    COPYRIGHT 2008 INTEL CORPORATION                       **
***	                           All Rights Reserved                            **
***                                                                           **
***                 INTEL CORPORATION PROPRIETARY INFORMATION                 **
***                                                                           **
***		The source code contained or described herein and all documents	      **
***		related to the source code ("Material") are owned by Intel            **
***		Corporation or its suppliers or licensors. Title to the Material      **
***		remains with Intel Corporation or its suppliers and licensors.        **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.                  **
***		The Material is protected by worldwide copyright and trade secret     **
***		laws and treaty provisions. No part of the Material may be used,      **
***		copied, reproduced, modified, published, uploaded, posted,	          **
***		transmitted, distributed, or disclosed in any way without Intels     **
***		prior express written permission.                                     **
***	                                                                          **
***		No license under any patent, copyright, trade secret or other         **
***		intellectual property right is granted to or conferred upon you by    **
***		disclosure or delivery of the Materials, either expressly, by         **
***		implication, inducement, estoppel or otherwise. Any license under     **
***		such intellectual property rights must be express and approved by     **
***		Intel in writing.                                                     **
********************************************************************************/


#ifndef _LOG_SINK_ODS_H
#define _LOG_SINK_ODS_H

#include "Logger.h"

namespace TransportPlugin
{

/**
 * Implementation of the LogSink that logs messages
 * using OutputDebugString() Windows API.
 */
class LogSinkOds : public LogSink
{
public:
    /**
     * Ctor.
     * @param logLevel Logging verbosity level.
     */
    LogSinkOds(int logLevel);

    /**
     * Logs a message to the debugger.
     *
     * @param msgLevel Log level of the current message.
     * @param msg Message to log.
     */
    virtual void log(unsigned int msgLevel, const char* msg);
};

}

#endif //_LOG_SINK_ODS_H
