/*******************************************************************************
********************************************************************************
***                                                                           **
***	                           INTEL CONFIDENTIAL                             **
***                    COPYRIGHT 2008 INTEL CORPORATION                       **
***	                           All Rights Reserved                            **
***                                                                           **
***                 INTEL CORPORATION PROPRIETARY INFORMATION                 **
***                                                                           **
***		The source code contained or described herein and all documents	      **
***		related to the source code ("Material") are owned by Intel            **
***		Corporation or its suppliers or licensors. Title to the Material      **
***		remains with Intel Corporation or its suppliers and licensors.        **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.                  **
***		The Material is protected by worldwide copyright and trade secret     **
***		laws and treaty provisions. No part of the Material may be used,      **
***		copied, reproduced, modified, published, uploaded, posted,	          **
***		transmitted, distributed, or disclosed in any way without Intels     **
***		prior express written permission.                                     **
***	                                                                          **
***		No license under any patent, copyright, trade secret or other         **
***		intellectual property right is granted to or conferred upon you by    **
***		disclosure or delivery of the Materials, either expressly, by         **
***		implication, inducement, estoppel or otherwise. Any license under     **
***		such intellectual property rights must be express and approved by     **
***		Intel in writing.                                                     **
********************************************************************************/


#include "OsSpecificCritSectLinux.h"

namespace TransportPlugin
{
OsSpecificCritSect*
OsSpecificCritSect::CreateCritSectObject()
{
    return new OsSpecificCritSectLinux();
}

OsSpecificCritSectLinux::OsSpecificCritSectLinux()
{
    pthread_mutexattr_t mutexattr;
    pthread_mutexattr_settype(&mutexattr, PTHREAD_MUTEX_RECURSIVE_NP);
    pthread_mutex_init(&this->mutex, &mutexattr);
    pthread_mutexattr_destroy(&mutexattr);
}

OsSpecificCritSectLinux::~OsSpecificCritSectLinux()
{
    pthread_mutex_destroy(&this->mutex);
}

void
OsSpecificCritSectLinux::EnterCritSect()
{
    pthread_mutex_lock(&this->mutex);
}

void
OsSpecificCritSectLinux::LeaveCritSect()
{
    pthread_mutex_unlock(&this->mutex);
}
}
