/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008 INTEL CORPORATION                       **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/

#include "RemoteLogger.h"

using namespace std;

namespace TransportPlugin
{

dcmi_logger_fun_t RemoteLogger::pLoggerFun = NULL;
std::string RemoteLogger::logPrefix;

RemoteLogger::RemoteLogger()
{
    // If static member logPrefix is defined, set initial value of the message.
    if (!logPrefix.empty())
    {
        *this << logPrefix << " ";
    }
}

RemoteLogger::~RemoteLogger()
{
    try
    {
        if (pLoggerFun != NULL)
        {
  //          *this << endl;
            (*pLoggerFun)(msgLevel, str().c_str());
        }
    }
    catch (...)
    {};
}

void
RemoteLogger::setLoggerFunc(dcmi_logger_fun_t loggerFun)
{
    RemoteLogger::pLoggerFun = loggerFun;
}

void
RemoteLogger::setLogPrefix(const char* newLogPrefix)
{
    stringstream s;
    s << "\n[" << newLogPrefix << "]:";
    logPrefix = s.str();
}

}
