/*******************************************************************************
********************************************************************************
***                                                                           **
***	                           INTEL CONFIDENTIAL                             **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***	                           All Rights Reserved                            **
***                                                                           **
***                 INTEL CORPORATION PROPRIETARY INFORMATION                 **
***                                                                           **
***		The source code contained or described herein and all documents	      **
***		related to the source code ("Material") are owned by Intel            **
***		Corporation or its suppliers or licensors. Title to the Material      **
***		remains with Intel Corporation or its suppliers and licensors.        **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.                  **
***		The Material is protected by worldwide copyright and trade secret     **
***		laws and treaty provisions. No part of the Material may be used,      **
***		copied, reproduced, modified, published, uploaded, posted,	          **
***		transmitted, distributed, or disclosed in any way without Intels      **
***		prior express written permission.                                     **
***	                                                                          **
***		No license under any patent, copyright, trade secret or other         **
***		intellectual property right is granted to or conferred upon you by    **
***		disclosure or delivery of the Materials, either expressly, by         **
***		implication, inducement, estoppel or otherwise. Any license under     **
***		such intellectual property rights must be express and approved by     **
***		Intel in writing.                                                     **
********************************************************************************/

#ifndef _TRANSPORT_PLUGIN_COMMON_H
#define _TRANSPORT_PLUGIN_COMMON_H

#include <ostream>
#include <string>
#include <map>

#include "CommonClasses.hpp"

namespace TransportPlugin
{

const int MAX_RETRY_COUNT=3;



class TransportPlugIn
{

public:

	TransportPlugIn () {};
	virtual ~TransportPlugIn () {};

	virtual bool isConnected()  = 0;

	virtual int connect() = 0;

	virtual int openSession() = 0;

	virtual int closeSession() = 0;

	virtual void disconnect() = 0;

	virtual transport_plugin_id connectionType() = 0;

	virtual int configure(const std::string &name, const std::string &value) = 0;

	virtual int sendIpmiCmd(CommonClasses::Request &req, CommonClasses::Response &resp, byte_t retryCount) = 0;
};


} //end namespace

#endif //#ifndef _TRANSPORT_PLUGIN_COMMON_H
