/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2011 INTEL CORPORATION                       **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
/*
 * DeviceIoControl.h
 *
 *  Created on: 01-06-2011
 */

#ifndef DEVICEIOCONTROL_H_
#define DEVICEIOCONTROL_H_

#ifndef WIN32

#include <sys/ioctl.h>

typedef enum {FALSE=0, TRUE}	BOOL;
typedef unsigned int			DWORD;
typedef int 					HANDLE;

typedef unsigned short			WORD;
typedef unsigned char   		BYTE;

#define far
typedef void  far *				LPVOID;
typedef DWORD far *				LPDWORD;

#define IMB_SUCCESS				0L

//#pragma pack(1)
typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
/*    HANDLE  hEvent; */
} OVERLAPPED, *LPOVERLAPPED;

/*
 * DCMI data struct used by ioctl interface.
 * Pointer to struct smi is the only defined parameter of IOCTL_IMB_SEND_MESSAGE command.
 */
struct smi {
    DWORD smi_VersionNo;		/* not used by Linux DoH driver */
    DWORD smi_Reserved1;		/* not used by Linux DoH driver */
    DWORD smi_Reserved2;		/* not used by Linux DoH driver */
    LPVOID ntstatus;			/* address of NT status block, not used in Linux DoH driver */
    LPVOID  lpvInBuffer;        /* address of buffer for input data, see ImbRequestBuffer*/
    DWORD  cbInBuffer;  		/* size of input buffer*/
    LPVOID  lpvOutBuffer;       /* address of output buffer, see ImbResponseBuffer*/
    DWORD  cbOutBuffer; 		/* size of output buffer*/
    LPDWORD  lpcbBytesReturned; /* address of actual bytes of output*/
    LPOVERLAPPED  lpoOverlapped;/* address of overlapped structure, not used in Linux DoH driver */
};
//#pragma pack()

/* IOCTL commands codes like in IPMI linux driver for compatibility */
#define FILE_DEVICE_IMB		0x00008010
#define IOCTL_IMB_BASE		0x00000880
#define CTL_CODE(DeviceType, Function, Method, Access) \
		_IO((DeviceType) & 0x00FF, (Function) & 0x00FF)


#ifdef __cplusplus
extern "C" {
#endif

BOOL DeviceIoControl(
						HANDLE 			hDevice, /* handle of device */
						DWORD 			dwIoControlCode, /* control code of operation to perform*/
						LPVOID 			lpvInBuffer, /* address of buffer for input data */
						DWORD 			cbInBuffer, /* size of input buffer */
						LPVOID 			lpvOutBuffer, /* address of output buffer */
						DWORD 			cbOutBuffer, /* size of output buffer */
						LPDWORD 		lpcbBytesReturned, /* address of actual bytes of output */
						LPOVERLAPPED 		lpoOverlapped /* address of overlapped struct */
					);


#ifdef __cplusplus
}
#endif

#endif //Win32

#endif /* DEVICEIOCONTROL_H_ */
