/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2011 INTEL CORPORATION                       **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
#ifndef _IPMI_DEV_LINUX_H
#define _IPMI_DEV_LINUX_H

/**
 * Provides an access to the Open IPMI driver
 */
class IpmiDevIpmi0Impl : public IpmiProxy
{
public:
    /**
     * The default ctor opens a connection to the OpenIPMI
     * driver and configures the driver.
     */
	IpmiDevIpmi0Impl();

    /**
     * Dtor.
     */
    ~IpmiDevIpmi0Impl();

    /**
     * Sends IPMI command to BMC via IPMI driver and receives response.
     *
     * @param req IPMI request that is passed to the OpenIPMI driver.
     * @return IPMI response that is retrieved from the OpenIPMI driver.
     */
    virtual IpmiResponse requestResponse(const IpmiRequest& req);

private:
    int ipmiDrvHandle;

    unsigned int ipmiReqMsgId;
};

#endif //#ifndef _IPMI_DEV_LINUX_H
