/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/

#include <iostream>
#include <stdexcept>
#include "IpmiRequest.h"

#include <iomanip>

using namespace std;

IpmiRequest::IpmiRequest(unsigned char dest, unsigned char netFn,
                                           unsigned char lun, unsigned int cmd,
                                           unsigned int dataLen, const unsigned char* data)
                    :dest(dest), netFn(netFn), lun(lun), cmd(cmd)
{
    if (dataLen > 0)
    {
        this->data.assign(data, data + dataLen);
    }
}

std::ostream&
operator<<(std::ostream& os, const IpmiRequest& req)
{
    os << "net_fn: 0x" << hex << setw(2) << setfill('0') << (int)req.getNetFn()
            << " LUN: 0x" << hex << setw(2) << setfill('0') << (int)req.getLun()
            << " cmd: 0x" << hex << setw(2) << setfill('0') << (int)req.getCmd()
            << " data size: " << dec << req.getData().size() << " [ ";
    for (size_t i = 0; i < req.getData().size(); ++i)
    {
        os << hex << setw(2) << setfill('0') << (int)req.getData()[i] << " ";
    }
    os << "]";
    return os;
}
