/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008,2011 INTEL CORPORATION                  **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intels	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
#ifndef __VERSION_COMMON_H__
#define __VERSION_COMMON_H__

#if !defined(MAJOR_VERSION)
#error Define MAJOR_VERSION before including __FILE__ !
#endif
#if !defined(MINOR_VERSION)
#error Define MINOR_VERSION before including __FILE__ !
#endif
#if !defined(QUICK_FIX_NUMBER)
#error Define QUICK_FIX_NUMBER before including __FILE__ !
#endif
#if !defined(VER_BUILD)
#error Define VER_BUILD before including __FILE__ !
#endif


/*
 * For Windows compatibility ... */
#ifndef __stringify
#define __stringify_1(x)     #x
#define __stringify(x)       __stringify_1(x)
#endif

#define MAKE_VER_STRING(maj, min, submin, bld)   __stringify(maj) "." __stringify(min) "." __stringify(submin) "." __stringify(bld)

#define VER_PRODUCTVERSION          MAJOR_VERSION,MINOR_VERSION,QUICK_FIX_NUMBER,VER_BUILD
#define VER_PRODUCTVERSION_STR      MAKE_VER_STRING(MAJOR_VERSION, MINOR_VERSION, QUICK_FIX_NUMBER, VER_BUILD)

#endif
